import org.junit.Assert;
import org.junit.Rule;
import org.junit.Test;
import org.junit.rules.Timeout;

import java.lang.reflect.Field;
import java.util.LinkedList;

import static org.hamcrest.CoreMatchers.is;

public class Aufgabe1Test {

    @Rule
    public Timeout globalTimeout = Timeout.millis(1000);

    @Test
    public void testPointEquals() throws Exception {
        Point p = new Point(-1,2);
        for (int x = -5; x < 5; x++) {
            for (int y = -5; y < 5; y++) {
                Assert.assertTrue((x == -1 && y == 2) == new Point(x,y).equals(p));
            }
        }
    }

    @Test
    public void testPointToString() throws Exception {
        Point p = new Point(-1,2);
        Assert.assertThat(p.toString().replaceAll("\\s",""), is("(-1,2)"));
    }

    @Test
    public void testPlaneAdd() throws Exception {
        Plane plane = new Plane();

        plane.add(new Point(1,2));
        plane.add(2,0);
        plane.add(2,2);
        plane.add(new Point(0,2));
        plane.add(new Point(2,1));



        Field field = Plane.class.getDeclaredField("list");
        field.setAccessible(true);

        LinkedList<Point> listA = (LinkedList<Point>) field.get(plane);
        LinkedList<Point> listB = new LinkedList<Point>();

        listB.add(new Point(1,2));
        listB.add(new Point(2,0));
        listB.add(new Point(2,2));
        listB.add(new Point(0,2));
        listB.add(new Point(2,1));

        Assert.assertTrue(listA.containsAll(listB) && listB.containsAll(listA));
    }

    @Test
    public void testPlaneToString() throws Exception {
        Plane plane = new Plane();

        plane.add(new Point(1,2));
        plane.add(new Point(2,0));
        plane.add(new Point(2,2));
        plane.add(new Point(0,2));
        plane.add(new Point(2,1));
        String result = "(1,2)\n" +
                "(2,0)\n" +
                "(2,2)\n" +
                "(0,2)\n" +
                "(2,1)\n";
        Assert.assertThat(plane.toString(), is(result));
    }

    @Test
    public void testPlaneMoveSelection() throws Exception {
        Plane plane = new Plane();

        plane.add(new Point(2,2));
        plane.add(new Point(0,2));
        plane.add(new Point(2,1));
        plane.selectNearestTo(new Point(0,0));
        plane.moveSelection(5);

        Field field = Plane.class.getDeclaredField("list");
        field.setAccessible(true);

        LinkedList<Point> listA = (LinkedList<Point>) field.get(plane);
        LinkedList<Point> listB = new LinkedList<Point>();

        listB.add(new Point(2,2));
        listB.add(new Point(5,2));
        listB.add(new Point(2,1));

        Assert.assertTrue(listA.containsAll(listB) && listB.containsAll(listA));

    }

    @Test
    public void testPlaneToStringAndSelection() throws Exception {
        Plane plane = new Plane();

        plane.add(new Point(1,2));
        plane.add(new Point(2,0));
        plane.add(new Point(2,2));
        plane.add(new Point(0,2));
        plane.add(new Point(2,1));
        plane.selectNearestTo(new Point(0,0));
        String result = "(1,2)\n" +
                "(2,0)\n" +
                "(2,2)\n" +
                "[(0,2)]\n" +
                "(2,1)\n";
        Assert.assertThat(plane.toString(), is(result));
    }

    @Test
    public void testPlaneCopyAndPointMove() throws Exception {
        Plane plane = new Plane();

        plane.add(new Point(1,2));

        Field field = Plane.class.getDeclaredField("list");
        field.setAccessible(true);

        Plane copy = new Plane(plane);

        LinkedList<Point> listA = (LinkedList<Point>) field.get(plane);
        LinkedList<Point> listB = (LinkedList<Point>) field.get(copy);
        Assert.assertTrue(listA.containsAll(listB) && listB.containsAll(listA));

        listA.getFirst().moveHorizontal(5);
        listA.getFirst().equals(new Point(6,2));
        listB.getFirst().equals(new Point(1,2));

    }

}