import org.junit.Assert;
import org.junit.Test;

import static org.hamcrest.CoreMatchers.is;
import static org.junit.Assert.assertEquals;

public class Aufgabe2Test {

    @Test
    public void testToStringEmpty() throws Exception {

        List l1 = new List();

        assertEquals(l1.toString().replaceAll(" ", ""), "[-|]");
    }

    @Test
    public void testToString() throws Exception {

        List l1 = new List();
        l1.add(5);
        l1.add(1);
        l1.add(9);
        l1.add(3);
        l1.add(6);
        l1.add(5);

        Assert.assertThat(l1.toString().replaceAll(" ", ""), is("[->9->6->5->5->3->1-|]"));
    }

    @Test
    public void testAddLastEmpty() throws Exception {

        List l1 = new List();

        l1.addLast(4);

        Assert.assertThat(l1.toString().replaceAll(" ", ""), is("[->4-|]"));
    }

    @Test
    public void testAddLast() throws Exception {

        List l1 = new List();
        l1.add(4);
        l1.add(2);

        l1.addLast(1);

        Assert.assertThat(l1.toString().replaceAll(" ", ""), is("[->1->4->2-|]"));
    }

    @Test
    public void testSumEvenElementsEmpty() throws Exception {

        List l1 = new List();

        int res = l1.sumEvenElements();
        Assert.assertThat(res, is(-1));
    }

    @Test
    public void testSumEvenElements() throws Exception {

        List l1 = new List();
        l1.add(5);
        l1.add(1);
        l1.add(9);
        l1.add(2);
        l1.add(6);
        l1.add(5);

        int res = l1.sumEvenElements();
        Assert.assertThat(res, is(8));

        Assert.assertThat(l1.toString().replaceAll(" ", ""), is("[->9->6->5->5->2->1-|]"));
    }

}